From 1c7e7a385387d7febf633bbb6d2b99ece523e719 Mon Sep 17 00:00:00 2001
From: Alexander Kanavin <alex.kanavin@gmail.com>
Date: Thu, 11 Aug 2016 17:13:51 +0300
Subject: [PATCH] Tweak gtkdoc settings so that gtkdoc generation works under
 OpenEmbedded build system

This requires setting a few environment variables so that the transient
binary is build and linked correctly, and disabling the tweaks to RUN
variable from gtkdoc.py script so that our qemu wrapper is taken into use.

Upstream-Status: Inappropriate [oe-specific]
Signed-off-by: Alexander Kanavin <alex.kanavin@gmail.com>

---
 Source/cmake/GtkDoc.cmake | 2 +-
 Tools/gtkdoc/gtkdoc.py    | 4 ++--
 2 files changed, 3 insertions(+), 3 deletions(-)

diff --git a/Source/cmake/GtkDoc.cmake b/Source/cmake/GtkDoc.cmake
index 18e86448..102c873a 100644
--- a/Source/cmake/GtkDoc.cmake
+++ b/Source/cmake/GtkDoc.cmake
@@ -4,7 +4,7 @@ macro(ADD_GTKDOC_GENERATOR _stamp_name _extra_args)
     add_custom_command(
         OUTPUT "${CMAKE_BINARY_DIR}/${_stamp_name}"
         DEPENDS ${DocumentationDependencies}
-        COMMAND ${CMAKE_COMMAND} -E env "CC=${CMAKE_C_COMPILER}" "CFLAGS=${CMAKE_C_FLAGS} -Wno-unused-parameter" "LDFLAGS=${CMAKE_EXE_LINKER_FLAGS}" ${PYTHON_EXECUTABLE} ${CMAKE_SOURCE_DIR}/Tools/gtkdoc/generate-gtkdoc ${_extra_args}
+        COMMAND ${CMAKE_COMMAND} -E env "CC=${CMAKE_C_COMPILER}" "CFLAGS=${CMAKE_C_FLAGS} -Wno-unused-parameter" "LD=${CMAKE_C_COMPILER}" "LDFLAGS=${CMAKE_C_LINK_FLAGS}" "RUN=${CMAKE_BINARY_DIR}/gtkdoc-qemuwrapper" ${PYTHON_EXECUTABLE} ${CMAKE_SOURCE_DIR}/Tools/gtkdoc/generate-gtkdoc ${_extra_args}
         COMMAND touch ${_stamp_name}
         WORKING_DIRECTORY "${CMAKE_BINARY_DIR}"
         VERBATIM
diff --git a/Tools/gtkdoc/gtkdoc.py b/Tools/gtkdoc/gtkdoc.py
index 054cafa1..416de7d1 100644
--- a/Tools/gtkdoc/gtkdoc.py
+++ b/Tools/gtkdoc/gtkdoc.py
@@ -320,9 +320,9 @@ class GTKDoc(object):
                     additional_ldflags = '%s %s' % (additional_ldflags, arg)
             ldflags = ' "-L%s" %s ' % (self.library_path, additional_ldflags) + ldflags
             current_ld_library_path = env.get('LD_LIBRARY_PATH')
-            if current_ld_library_path:
+            if current_ld_library_path and 'RUN' not in env:
                 env['LD_LIBRARY_PATH'] = '%s:%s' % (self.library_path, current_ld_library_path)
-            else:
+            elif 'RUN' not in env:
                 env['LD_LIBRARY_PATH'] = self.library_path
 
         if ldflags:
